""" Implementation of the cost model used for vectorization
"""


def ilp_heuristic(sf):
    """ A heuristic measure for the ILP capabilities of the kernel

    Return is the throttle of insufficient ILP, generally in (0., 1.0].
    1.0 indicates perfect instruction level parallelism.
    """ 
    return 1.0


def vectorization_costfunction(sf):
    # kernel characteristics necessary
    traffic = sf.memory_traffic
    intensity = sf.operations / sf.memory_traffic

    # hardware characteristics necessary
    bandwidth = 100000000000000000.0
    peakperformance = 100.0

    roofline = min(bandwidth * intensity, ilp_heuristics(sf) * peakperformance)

    return (traffic * intensity) / roofline
